--Guardian Module

import "Turbine.Gameplay.Attributes"

	Player = Turbine.Gameplay.LocalPlayer.GetInstance();
	PlayerAttributes=Player:GetClassAttributes()
	Proc=true	--Flag to show a proc module is loaded
	proclist	={"BT1","BT2","BT3","PT1","PT2","PT3","PT4"}
function initialiseproc()
	procwatcher()
	procupdate()
end

function procwatcher()
	--Watch for change
	PlayerAttributes.IsBlockTier1AvailableChanged = function( sender, args )
		BT1=PlayerAttributes:IsBlockTier1Available()
		procupdate("BT1",BT1)
	end
	PlayerAttributes.IsBlockTier2AvailableChanged = function( sender, args )
		BT2=PlayerAttributes:IsBlockTier2Available()
		procupdate("BT2",BT2)
	end
	PlayerAttributes.IsBlockTier3AvailableChanged = function( sender, args )
		BT3=PlayerAttributes:IsBlockTier3Available()
		procupdate("BT3",BT3)
	end
	PlayerAttributes.IsParryTier1AvailableChanged = function( sender, args )
		PT1=PlayerAttributes:IsParryTier1Available()
		procupdate("PT1",PT1)
	end
	PlayerAttributes.IsParryTier2AvailableChanged = function( sender, args )
		PT2=PlayerAttributes:IsParryTier2Available()
		procupdate("PT2",PT2)
	end
	PlayerAttributes.IsParryTier3AvailableChanged = function( sender, args )
		 PT3=PlayerAttributes:IsParryTier3Available()
		procupdate("PT3",PT3)
	end
end

function procupdate(proc,flag)
if flag then geoff=" true" else geoff=" false"  end

if proc==nil then
	--If this has been called by an external module (i.e. UI locked) then a full hide is required
	--This means if a player is in combat and he locks the UI he may lose some info. Very unlikely.
	Turbine.Shell.WriteLine("Recieved Nil")
	for i=1,#proclist do
		procupdate(proclist[i],false)
	end
	return
end

Turbine.Shell.WriteLine(proc..geoff)

		for i=1,#Bar do
			if Bar[i]~=nil then
				if Bar[i].Data.proc~=nil then
					if Bar[i].Data.proc==proc then if flag then Bar[i]:Show() else Bar[i]:Hide() end end
				end
			end
		end
end
table.insert(Context,
function procoption(self,contextMenu,contextMenuItems)
--Add the "guardian Bar" option to every Bar.
			local procBar = Turbine.UI.MenuItem( "Show only when...");
				contextMenu.procs = procBar:GetItems()
				procMenu={}

					procMenu[1] = Turbine.UI.MenuItem( "Block Tier 1",true,self.Data.proc=="BT1");
					procMenu[1].Click = function( sender, args )
						if self.Data.proc=="BT1" then
							self.Data.proc=nil
						else
							self.Data.proc="BT1"
						end
						procupdate()
					end
					contextMenu.procs:Add(procMenu[1])

					procMenu[2] = Turbine.UI.MenuItem( "Block Tier 2",true,self.Data.proc=="BT2");
					procMenu[2].Click = function( sender, args )
						if self.Data.proc=="BT2" then
							self.Data.proc=nil
						else
							self.Data.proc="BT2"
						end
						procupdate()
					end
					contextMenu.procs:Add(procMenu[2])

					procMenu[3] = Turbine.UI.MenuItem( "Block Tier 3",true,self.Data.proc=="BT3");
					procMenu[3].Click = function( sender, args )
						if self.Data.proc=="BT3" then
							self.Data.proc=nil
						else
							self.Data.proc="BT3"
						end
						procupdate()
					end
					contextMenu.procs:Add(procMenu[3])

					procMenu[4] = Turbine.UI.MenuItem( "Parry Tier 1",true,self.Data.proc=="PT1");
					procMenu[4].Click = function( sender, args )
						if self.Data.proc=="PT1" then
							self.Data.proc=nil
						else
							self.Data.proc="PT1"
						end
						procupdate()
					end
					contextMenu.procs:Add(procMenu[4])		

					procMenu[5] = Turbine.UI.MenuItem( "Parry Tier 2",true,self.Data.proc=="PT2");
					procMenu[5].Click = function( sender, args )
						if self.Data.proc=="PT2" then
							self.Data.proc=nil
						else
							self.Data.proc="PT2"
						end
						procupdate()
					end
					contextMenu.procs:Add(procMenu[5])		

					procMenu[6] = Turbine.UI.MenuItem( "Parry Tier 3",true,self.Data.proc=="PT3");
					procMenu[6].Click = function( sender, args )
						if self.Data.proc=="PT3" then
							self.Data.proc=nil
						else
							self.Data.proc="PT3"
						end
						procupdate()
					end
					contextMenu.procs:Add(procMenu[6])		

			contextMenuItems:Add( procBar )

end)

initialiseproc()